<?php
    //error_reporting(0);
    
    $ip_from =        $_REQUEST["ip_from"];
    $ip_to =          $_REQUEST["ip_to"];
    $vlan_id  =       $_REQUEST["vlan_id"];
    $community  =     $_REQUEST["community"];
     
    include_once("table_header.php");
    
    include_once("config.php");
    include_once("config_device_id.php");

    if($community==="" || $community===null || !isset($community)) $community=$default_community;
    $ip_switch=array();
    $switch_name=array();

    list($ip_from1,$ip_from2,$ip_from3,$ip_from4)=explode('.',$ip_from);
    list($ip_to1,$ip_to2,$ip_to3,$ip_to4)=explode('.',$ip_to);
    
    for($i=$ip_from4;$i<=$ip_to4;$i++)
    {
        $ip=$ip_from1.'.'.$ip_from2.'.'.$ip_from3.'.'.$i;
        $device=get_device_vendor($ip,$community,$snmp_timeout,$snmp_retry,$replace_table);
        if(isset($device))
        {    
            $device_idd=$device_id[$device];
            $a_vlans_id=@get_snmp_walk($ip,$community,$device_idd["vlans_id"],$snmp_timeout,$replace_table, $snmp_retry);
            if(count($a_vlans_id)===0 || $a_vlans_id[0]==="No Such Object available on this agent at this OID" || $a_vlans_id[0]==="Owner") //for other type of switches for example juniper 4300 and 4550
            {
                $a_vlans_id=@get_snmp_walk($ip,$community,$device_idd["ifDescr"],$snmp_timeout,$replace_table, $snmp_retry);
                //if(count($a_vlans_id)===0 || $a_vlans_id[0]==="No Such Object available on this agent at this OID" || $a_vlans_id[0]==="Owner")
                //{
                //    $a_vlans_id=@get_snmp_walk($ip,$community,$device_idd["ifDescr"],$snmp_timeout,$replace_table);
                //}
            }
            $vlans[$ip]=$a_vlans_id;
            for($j=0;$j<count($a_vlans_id);$j++)
            {
                $snmp_vlan_id=$a_vlans_id[$j];
                if((int)$vlan_id===0)
                {
                    $ip_switch[]=$ip;
                    break;
                }
                if((int)$snmp_vlan_id===(int)$vlan_id)
                {
                    $ip_switch[]=$ip;
                    break;
                }
            }
        }
    }

    $ip_switch_u=array_unique($ip_switch,SORT_STRING); //usuwanie zdyblowanych adresow IP
    //sw name
    for($i=0;$i<count($ip_switch_u);$i++)
    {
        $ip=$ip_switch_u[$i];
        $switch_name[]= @get_snmp($ip,$community,'1.3.6.1.2.1.1.1.0', $snmp_timeout, $replace_table, $snmp_retry).' '.
                        @get_snmp($ip,$community,'1.3.6.1.2.1.1.5.0', $snmp_timeout, $replace_table, $snmp_retry).' '.
                        @get_snmp($ip,$community,'1.3.6.1.2.1.1.6.0', $snmp_timeout, $replace_table, $snmp_retry);
    }
    echo print_html($ip_switch_u,$vlans,$switch_name);
    
//=============================================================================================================    
    
function print_html($ip_switch,$vlans,$switch_name)
{    
    $count_i=count($ip_switch);
    if($count_i===0 || $count_i===null)
    {
        $html='<table border="1" width="100%" id="table_snmp" class="table_snmp">';
        $html.='    <tr>';
        $html.='        <td width="100%" align="center"><font face="Verdana" size="3">No data</font></td>';
        $html.='    </tr>	';
        $html.='</table>';
        return $html;
    }    
    
    $html='<table border="1" width="100%" id="table_snmp" class="table_snmp">';
    for($i=0;$i<$count_i;$i++)
    {
        $v_vlans_for_ip="";
        for($k=0;$k<count($vlans[$ip_switch[$i]]);$k++)
        {
            if(trim($vlans[$ip_switch[$i]][$k]) !== "")
                $v_vlans_for_ip.=$vlans[$ip_switch[$i]][$k]."<br /> ";
        }
        $html.='<tr class="tr_row_data">';
        $html.='    <td width="30%" align="left" valign="top" style="font-family: Verdana; font-size: 10px; font-weight: bold;">'.$ip_switch[$i].'</td>';
        $html.='    <td width="40%" align="left" valign="top">'.$v_vlans_for_ip.'</td>';
        $html.='    <td width="30%" align="left" valign="top">'.$switch_name[$i].'</td>';
        $html.='</tr>';
    }
    $html.='</table>';

    return $html;
}

function get_device_vendor($ip,$community,$snmp_timeout,$snmp_retry,$replace_table)
{
    list($d)=explode('.',str_replace('.1.3.6.1.4.1.','',get_snmp($ip,$community,'1.3.6.1.2.1.1.2.0', $snmp_timeout, $snmp_retry))); //model number
    return $d;
}

function get_snmp($ip,$community,$oid,$snmp_timeout,$replace_table, $snmp_retry)
{
    $a=array();
    if(!isset($oid) || $oid === null || $oid === '') return "";
    
    $last_line_snmp=exec("snmpget -v2c -On -r1 -t".$snmp_timeout." -c".$community." ".$ip." ".$oid,$a,$retvar2);
    $b=trim(str_replace('.1.3.6.1.2.1.1.2.0 = OID: .1.3.6.1.4.1.',"",$last_line_snmp));    
    //snmp_set_oid_output_format(SNMP_OID_OUTPUT_NUMERIC);
    //$b=trim(str_replace($replace_table,"",@snmpget($ip, $community, $oid, $snmp_timeout, $snmp_retry)));
    //$b=trim(str_replace('.1.3.6.1.2.1.1.2.0 = OID: .1.3.6.1.4.1.',"",$b));
    return $b;
}                

function get_snmp_walk($ip,$community,$oid,$snmp_timeout,$replace_table, $snmp_retry)
{    
    $a=array();
    exec("snmpwalk -v2c -Onv -r1 -t".$snmp_timeout." -c".$community." ".$ip." ".$oid,$a,$retvar2);    
    //snmp_set_oid_output_format(SNMP_OID_OUTPUT_NUMERIC);
    //$a=@snmpwalk($ip,$community,$oid, $snmp_timeout, $snmp_retry);
    $b=array();
    for ($i=0; $i<count($a); $i++)
    {
        $b[]=trim(str_replace($replace_table,"",$a[$i]));
    }
    return $b;
}

?>